

local o = ChatLinksMonitor1; if (o.SHOULD_LOAD == nil) then return; end


local l_t_Init; -- ()
local l_t_GetLocals; -- linksTable = ()
local l_t_UnregisterForAllEvents; -- ()

local l_OnEvent_CHAT_MSG; -- (event, msg)

local l_DispatchLinks; -- (linksTable, source)

local l_ParseString; -- (linksTable, text)


local l_linksTable;


do
	if (o.t_GetLocals ~= nil) then
		l_linksTable = o.t_GetLocals();
	else
		l_linksTable = {};
	end
end




function l_t_Init()
	l_t_Init = nil;
	o.t_Init = nil;
	
	local em = EventsManager1;
	em.AddCustomEvent("ChatLinksMonitor1_LINKS_FOUND", false);
	
	if (o.t_UnregisterForAllEvents ~= nil) then
		o.t_UnregisterForAllEvents();
	end
	o.t_UnregisterForAllEvents = l_t_UnregisterForAllEvents;
	
	local RFE = em.RegisterForEvent;
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_SYSTEM", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_SAY", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_YELL", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_LOOT", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_CHANNEL", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_GUILD", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_OFFICER", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_RAID", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_PARTY", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_WHISPER", false, true);
	RFE(l_OnEvent_CHAT_MSG, nil, "CHAT_MSG_WHISPER_INFORM", false, true);
end

o.t_Init = l_t_Init;



function l_t_GetLocals()
	l_t_GetLocals = nil;
	o.t_GetLocals = nil;
	
	return l_linksTable;
end

o.t_GetLocals = l_t_GetLocals;



function l_t_UnregisterForAllEvents()
	l_t_UnregisterForAllEvents = nil;
	o.t_UnregisterForAllEvents = nil;
	
	o.EventsManager1.UnregisterForAllEvents(l_OnEvent_CHAT_MSG);
end




function l_OnEvent_CHAT_MSG(event, text)
	l_ParseString(l_linksTable, text);
	l_DispatchLinks(l_linksTable, event);
end




function l_DispatchLinks(linksTable, source)
	if (#linksTable == 0) then return; end
	
	o.EventsManager1.DispatchEvent("ChatLinksMonitor1_LINKS_FOUND", linksTable, source);
	
	for index = #linksTable, 1, -1 do
		linksTable[index] = nil;
	end
end




do
	local stringmatch = string.match;
	
	function l_ParseString(linksTable, text)
		local arrayIndex = #linksTable;
		-- Don't use gmatch here, as this is called too often to be creating that many closures.
		local link, endPos = stringmatch(text, "(|cff%x%x%x%x%x%x|H[^:]+:[^|]+|h%[.-%]|h|r)()", 1);
		while (link ~= nil) do
			arrayIndex = (arrayIndex + 1);
			linksTable[arrayIndex] = link;
			link, endPos = stringmatch(text, "(|cff%x%x%x%x%x%x|H[^:]+:[^|]+|h%[.-%]|h|r)()", endPos);
		end
	end
end

