

local didLoad, o = LoadLibrary2("CommonParsingTooltip", 121);


if (didLoad == false) then
	return;
end
o.SHOULD_LOAD = nil;



if (o.TOOLTIP == nil) then
	tooltip = CreateFrame("GameTooltip", "CommonParsingTooltip1", nil, nil);
	o.TOOLTIP = tooltip;
	_G.CommonParsingTooltip1 = tooltip;
	
	
	-- This doesn't need to be identified as a GameTooltip.
	tooltip.GetObjectType = (function() return ("ParsingTooltip"); end);
	
	
	-- When a tooltip is set to something that doesn't exist or isn't cached, it will lose its owner. To counter this, the owner must be re-evaluated prior to all "Set" methods.
	local UIParent = UIParent;
	local metaLookup = getmetatable(tooltip).__index;
	for index, method in pairs(
	  {
		"SetBagItem",					"SetAction",						"SetAuctionItem",			"SetAuctionSellItem",
		"SetBuybackItem",			"SetCraftItem",				"SetCraftSpell",				"SetGuildBankItem",
		"SetHyperlink",				"SetInboxItem",				"SetInventoryItem",		"SetLootItem",
		"SetLootRollItem",			"SetMerchantCostItem",	"SetMerchantItem",			"SetPetAction",
		"SetPlayerBuff",				"SetQuestItem",				"SetQuestLogItem",		"SetQuestRewardSpell",
		"SetSendMailItem",			"SetShapeshift",				"SetSpell",						"SetTalent",
		"SetTrackingSpell",			"SetTradePlayerItem",		"SetTradeSkillItem",		"SetTradeTargetItem",
		"SetTrainerService",		"SetUnit",						"SetUnitBuff",					"SetUnitDebuff"
	  }
	) do
		local l_originalFunc = metaLookup[method];
		tooltip[method] = function(self, ...)
			if (self:IsOwned(UIParent) == nil) then
				self:SetOwner(UIParent, "ANCHOR_NONE");
			end
			self.currentMoneyValue = nil;
			return l_originalFunc(self, ...);
		end
	end
	tooltip:SetOwner(UIParent, "ANCHOR_NONE");
	
	
	tooltip:SetScript("OnTooltipAddMoney", (function(self, money) self.currentMoneyValue = money; end));
	
	
	local leftLines, rightLines = {}, {};
	tooltip.leftLines, tooltip.rightLines = leftLines, rightLines;
	
	local type = type;
	local rawget = rawget;
	local _G = _G;
	
	local metatable = {
		__index = function(self, key)
			if (type(key) == "number") then
				local line = _G["CommonParsingTooltip1Text" .. ((self == leftLines and "Left") or "Right") .. key];
				if (line ~= nil) then
					self[key] = line;
				end
				return line;
			else
				return rawget(self, key);
			end
		end
	};
	
	setmetatable(leftLines, metatable);
	setmetatable(rightLines, metatable);
	
	
	-- The GameTooltip object seems to expect the first 8 lines to already be there, like with GameTooltipTemplate.
	if (CommonParsingTooltip1TextLeft1 == nil) then
		for index = 1, 8 do
			tooltip:AddFontStrings(
			  tooltip:CreateFontString("CommonParsingTooltip1TextLeft" .. index),
			  tooltip:CreateFontString("CommonParsingTooltip1TextRight" .. index)
			);
		end
	end
end

