

local o = QuestDB_FullText1; if (o.SHOULD_LOAD == nil) then return; end


local l_t_Init; -- ()
local l_t_GetLocals; -- activeDB, activeDBCount = ()
local l_t_UnregisterForAllEvents; -- ()

local l_OnEvent_QuestLinksMonitor1_LINKS_FOUND; -- (linksTable, source)

local l_GetActiveDB; -- db, dbCount = ()
local l_GetErrata; -- errata = ()

local l_IsBanned; -- banned = (ID)
local l_SetBanned; -- banned = (ID, enabled)

local l_IsTextInFullText; -- isInFullText = (data, textToMatch, plain)
local l_PopulateFakeTooltip; -- (tooltip, ID)

local l_GetData; -- data = (ID)
local l_SetData; -- oldData, newData = (ID, data)
local l_BuildFullTextData; -- data = (ID)

local l_LoadStaticDB; -- (staticDB, doInit)
local l_ConvertData; -- (dbTable)


local tonumber = tonumber; -- PopulateFakeTooltip, GetData, SetData
local pairs = pairs; -- LoadStaticDB, ConvertData, OnEvent_QuestLinksMonitor1_LINKS_FOUND
local stringmatch = string.match; -- OnEvent_QuestLinksMonitor1_LINKS_FOUND, PopulateFakeTooltip, BuildFullTextData


local l_activeDB;
local l_activeDBCount;
local l_errata;
local l_banList;
do
	if (o.t_GetLocals ~= nil) then
		l_activeDB, l_activeDBCount = o.t_GetLocals();
	else
		l_activeDB = {};
		l_activeDBCount = 0;
	end
end




function l_t_Init()
	l_t_Init = nil;
	o.t_Init = nil;
	
	
	local saved = QuestDB_FullText1_SavedData;
	if (saved == nil) then
		saved = {};
		QuestDB_FullText1_SavedData = saved;
	end
	
	local errata = saved.errata;
	if (errata == nil) then
		errata = {};
		saved.errata = errata;
	end
	l_errata = errata;
	
	local banList = saved.banList;
	if (banList == nil) then
		banList = {};
		saved.banList = banList;
	end
	l_banList = banList;
	
	
	if (o.t_UnregisterForAllEvents ~= nil) then
		o.t_UnregisterForAllEvents();
	end
	o.t_UnregisterForAllEvents = l_t_UnregisterForAllEvents;
	
	local em = o.EventsManager1;
	local RFE = em.RegisterForEvent;
	RFE(l_OnEvent_QuestLinksMonitor1_LINKS_FOUND, nil, "QuestLinksMonitor1_LINKS_FOUND", false, false);
	local ACE = em.AddCustomEvent;
	ACE("QuestDB_FullText1_DB_LOADED", true);
	ACE("QuestDB_FullText1_DB_SIZE_CHANGED", false);
	ACE("QuestDB_FullText1_ENTRY_TEXT_CHANGED", false);
	ACE("QuestDB_FullText1_ENTRY_BAN_CHANGED", false);
	
	
	local key, value = next(l_errata);
	if (type(value) == "table") then
		l_ConvertData(l_errata);
	end
	local key, value = next(l_activeDB);
	if (type(value) == "table") then
		l_ConvertData(l_activeDB);
	end
	
	local count = l_LoadStaticDB((o.STATIC_DB or {}), true);
	o.STATIC_DB = nil;
	o.EventsManager1.DispatchEvent("QuestDB_FullText1_DB_LOADED");
	local oldCount = l_activeDBCount;
	l_activeDBCount = count;
	o.EventsManager1.DispatchEvent("QuestDB_FullText1_DB_SIZE_CHANGED", oldCount, count);
end

o.t_Init = l_t_Init;



function l_t_GetLocals()
	l_t_GetLocals = nil;
	o.t_GetLocals = nil;
	
	return l_activeDB, l_activeDBCount;
end

o.t_GetLocals = l_t_GetLocals;



function l_t_UnregisterForAllEvents()
	l_t_UnregisterForAllEvents = nil;
	o.t_UnregisterForAllEvents = nil;
	
	local UFE = o.EventsManager1.UnregisterForEvent;
	UFE(l_OnEvent_QuestLinksMonitor1_LINKS_FOUND, "QuestLinksMonitor1_LINKS_FOUND");
end




function l_OnEvent_QuestLinksMonitor1_LINKS_FOUND(linksTable)
	local ID, data;
	for index, link in pairs(linksTable) do
		ID = stringmatch(link, "%d+", 19);
		data = l_BuildFullTextData(ID);
		if (data ~= nil) then
			l_SetData(ID, data);
		end
	end
end




function l_GetActiveDB()
	return l_activeDB, l_activeDBCount;
end

o.GetActiveDB = l_GetActiveDB;



function l_GetErrata()
	return l_errata;
end

o.GetErrata = l_GetErrata;




function l_IsBanned(ID)
	return ((l_banList[tonumber(ID)] and true) or false);
end

o.IsBanned = l_IsBanned;



function l_SetBanned(ID, enabled)
	ID = tonumber(ID);
	enabled = ((enabled and true) or nil);
	if (l_banList[ID] ~= enabled) then
		local data;
		if (enabled == true) then
			data = l_BuildFullTextData(ID);
		end
		l_SetData(ID, data);
		
		l_banList[ID] = enabled;
		o.EventsManager1.DispatchEvent("QuestDB_FullText1_ENTRY_BAN_CHANGED", ID, (enabled or false));
	end
	return l_IsBanned(ID);
end

o.SetBanned = l_SetBanned;




do
	local stringfind = string.find;
	
	function l_IsTextInFullText(data, textToMatch, plain)
		return (stringfind(data, textToMatch, 1, plain) ~= nil);
	end
	
	o.IsTextInFullText = l_IsTextInFullText;
end



do
	local stringsub = string.sub;
	local _G = _G;
	local loc_QUEST_TOOLTIP_REQUIREMENTS = QUEST_TOOLTIP_REQUIREMENTS;
	
	function l_PopulateFakeTooltip(tooltip, ID)
		local data = l_GetData(ID);
		if (data == nil) then
			return;
		end
		
		local nameLine = stringmatch(data, "^([^\001]+)");
		tooltip:AddLine(nameLine, 1.0, 0.82, 0.0);
		
		local leftText, position = stringmatch(data, "^[^\001]+\001([^\001]+)\001?()", 1);
		local nextLeftText;
		local r, g, b;
		while (leftText ~= nil) do
			if (leftText == loc_QUEST_TOOLTIP_REQUIREMENTS) then
				r, g, b = 1.0, 0.82, 0.0;
			else
				r, g, b = 1.0, 1.0, 1.0;
			end
			
			nextLeftText, position = stringmatch(data, "([^\001]+)\001?()", position);
			if (nextLeftText ~= nil and stringmatch(nextLeftText, "^\002") ~= nil) then
				tooltip:AddDoubleLine(leftText, stringsub(nextLeftText, 2, -1), r, g, b, 1.0, 1.0, 1.0);
				leftText, position = stringmatch(data, "([^\001]+)\001?()", position);
			else
				tooltip:AddLine(leftText, r, g, b, true);
				leftText = nextLeftText;
			end
		end
		tooltip:Show();
	end
	
	o.PopulateFakeTooltip = l_PopulateFakeTooltip;
end




function l_GetData(ID)
	return l_activeDB[tonumber(ID)];
end

o.GetData = l_GetData;



function l_SetData(ID, newData)
	ID = tonumber(ID);
	if (ID == nil) then
		error("QuestDB_FullText1.SetData: ID is nil");
	end
	local oldData = l_activeDB[ID];
	
	if (l_banList[ID] == true) then
		return oldData, oldData, false;
	end
	
	if (oldData ~= newData) then
		l_activeDB[ID] = newData;
		l_errata[ID] = newData;
		
		local change = ((oldData == nil and newData ~= nil and 1) or (oldData ~= nil and newData == nil and -1) or 0);
		if (change ~= 0) then
			local oldSize = l_activeDBCount;
			local newSize = (oldSize + change);
			l_activeDBCount = newSize;
			o.EventsManager1.DispatchEvent("QuestDB_FullText1_DB_SIZE_CHANGED", oldSize, newSize);
		end
		
		o.EventsManager1.DispatchEvent("QuestDB_FullText1_ENTRY_TEXT_CHANGED", ID, oldData, newData);
		return oldData, newData, true;
	else
		return oldData, oldData, false;
	end
end

o.SetData = l_SetData;



do
	local tableconcat = table.concat;
	local CommonParsingTooltip1 = CommonParsingTooltip1;
	local l_fullTextArray = {};
	local loc_QUEST_TOOLTIP_ACTIVE = QUEST_TOOLTIP_ACTIVE;
	
	function l_BuildFullTextData(ID)
		CommonParsingTooltip1:SetHyperlink("quest:" .. ID);
		
		local leftLines = CommonParsingTooltip1.leftLines;
		local rightLines = CommonParsingTooltip1.rightLines;
		
		local arrayIndex = 0;
		local leftText, rightText;
		for index = 1, CommonParsingTooltip1:NumLines(), 1 do
			leftText = leftLines[index]:GetText();
			if (leftText ~= loc_QUEST_TOOLTIP_ACTIVE) then
				arrayIndex = (arrayIndex + 1);
				l_fullTextArray[arrayIndex] = leftText;
				
				rightText = rightLines[index]:GetText();
				if (rightText ~= nil and rightText ~= "") then
					arrayIndex = (arrayIndex + 1);
					l_fullTextArray[arrayIndex] = ("\002" .. rightText);
				end
			end
		end
		
		for index = #l_fullTextArray, (arrayIndex + 1), -1 do
			l_fullTextArray[index] = nil;
		end
		return tableconcat(l_fullTextArray, "\001");
	end
end




function l_LoadStaticDB(staticDB, doInit)
	local key, value = next(staticDB);
	if (type(value) == "table") then
		l_ConvertData(staticDB);
	end
	
	if (doInit == true) then
		for ID, data in pairs(l_errata) do
			if (staticDB[ID] ~= data) then
				staticDB[ID] = data;
			else
				l_errata[ID] = nil;
			end
		end
	else
		for ID, data in pairs(l_errata) do
			staticDB[ID] = data;
		end
	end
	
	for ID in pairs(l_banList) do
		staticDB[ID] = nil;
	end
	
	local count = 0;
	if (doInit == true) then
		for ID, data in pairs(staticDB) do
			l_activeDB[ID] = data;
			count = (count + 1);
		end
	else
		for ID, data in pairs(staticDB) do
			l_SetData(ID, data);
			count = (count + 1);
		end
	end
	return count;
end

o.LoadStaticDB = l_LoadStaticDB;



do
	local stringconcat = strconcat;
	
	function l_ConvertData(dbTable)
		local newData;
		local text, lastWasRight;
		for ID, dataTable in pairs(dbTable) do
			for index = 1, #dataTable, 1 do
				text = (dataTable[index] or " ");
				if (text == true) then
					lastWasRight = true;
				else
					if (lastWasRight == true) then
						lastWasRight = nil;
						newData = stringconcat(newData, "\001\002", text);
					else
						newData = ((newData == nil and text) or stringconcat(newData, "\001", text));
					end
				end
			end
			dbTable[ID] = newData;
			newData = nil;
		end
	end
end

