

local o = QuestLinksMonitor1; if (o.SHOULD_LOAD == nil) then return; end


local l_t_Init; -- ()
local l_t_GetLocals; -- linksTable = ()
local l_t_UnregisterForAllEvents; -- ()

local l_OnEvent_ChatLinksMonitor1_LINKS_FOUND; -- (linksTable, source)
local l_OnEvent_QUEST_LOG_UPDATE; -- ()

local l_DispatchLinks; -- (linksTable, source)

local l_ParseQuests; -- (linksTable)


local l_linksTable;


do
	if (o.t_GetLocals ~= nil) then
		l_linksTable = o.t_GetLocals();
	else
		l_linksTable = {};
	end
end




function l_t_Init()
	l_t_Init = nil;
	o.t_Init = nil;
	
	local em = EventsManager1;
	em.AddCustomEvent("QuestLinksMonitor1_LINKS_FOUND", false);
	
	if (o.t_UnregisterForAllEvents ~= nil) then
		o.t_UnregisterForAllEvents();
	end
	o.t_UnregisterForAllEvents = l_t_UnregisterForAllEvents;
	
	local RFE = em.RegisterForEvent;
	RFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, nil, "ChatLinksMonitor1_LINKS_FOUND", false, false);
	RFE(l_OnEvent_QUEST_LOG_UPDATE, nil, "QUEST_LOG_UPDATE", false, false);
end

o.t_Init = l_t_Init;



function l_t_GetLocals()
	l_t_GetLocals = nil;
	o.t_GetLocals = nil;
	
	return l_linksTable;
end

o.t_GetLocals = l_t_GetLocals;



function l_t_UnregisterForAllEvents()
	l_t_UnregisterForAllEvents = nil;
	o.t_UnregisterForAllEvents = nil;
	
	local UFE = o.EventsManager1.UnregisterForEvent;
	UFE(l_OnEvent_ChatLinksMonitor1_LINKS_FOUND, "ChatLinksMonitor1_LINKS_FOUND");
	UFE(l_OnEvent_QUEST_LOG_UPDATE, "QUEST_LOG_UPDATE");
end




do
	local pairs = pairs;
	local stringfind = string.find;
	
	function l_OnEvent_ChatLinksMonitor1_LINKS_FOUND(linksTable, source)
		local arrayIndex = #l_linksTable;
		for index, link in pairs(linksTable) do
			if (stringfind(link, "quest:", 13, true) ~= nil) then
				arrayIndex = (arrayIndex + 1);
				l_linksTable[arrayIndex] = link;
			end
		end
		l_DispatchLinks(l_linksTable, ("chat-" .. source));
	end
end



function l_OnEvent_QUEST_LOG_UPDATE()
	l_ParseQuests(l_linksTable);
	l_DispatchLinks(l_linksTable, "log");
end




function l_DispatchLinks(linksTable, source)
	if (#linksTable == 0) then return; end
	
	o.EventsManager1.DispatchEvent("QuestLinksMonitor1_LINKS_FOUND", linksTable, source);
	
	for index = #linksTable, 1, -1 do
		linksTable[index] = nil;
	end
end




do
	local GetNumQuestLogEntries = GetNumQuestLogEntries;
	local GetQuestLink = GetQuestLink;
	
	function l_ParseQuests(linksTable)
		local link;
		local arrayIndex = #linksTable;
		
		for index = GetNumQuestLogEntries(), 1, -1 do
			link = GetQuestLink(index);
			if (link ~= nil) then
				arrayIndex = (arrayIndex + 1);
				linksTable[arrayIndex] = link;
			end
		end
	end
end

